//Mohammed Makki , mmakki2015@my.fit.edu, CSE1502
//Input the @username of the follower and increment a “follow” variable
//Retrieve previous tweets that were posted by the user from a text file and display the tweets 
//Acquire the number of his or her followers from a text file and display this number
//Store the tweet in a text file
#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
using namespace std;

string username = "None";
string nonsense = "";
fstream tweetFile;
fstream followFile("followers.txt");
string followLine = "";
int tweetIter = 0;
int numTweets = 0;
int input = 0;
int numFollows = 0;
string tweets[50];
string followers[50];
string tweetTopics = "";
bool q = false;
string say = "";

string atUser(string user) {
	string ret = "@";

	for (int i = 0; i < user.length(); i++) {
		if (user[i] != ' ') {
			ret = ret + user[i];
		}
	}

	return ret;
}

string scanTopics(string tweet) {
	string ret = "";

	for (int i = 0; i < tweet.length(); i++) {
		if (tweet[i] == '#') {
			for (int j = i; j < tweet.length(); j++) {
				if (tweet[j] == ' ') {
					break;
				}
				else {
					ret = ret + tweet[j];
				}
			}
		}
	}

	return ret;
}

void displayTweets() {
	tweetIter = numTweets;
	tweetTopics = "";

	while (tweetIter--) {
		for (int j = 0; j < 79; j++) {
			cout << '-';
		}
		cout << endl;
		cout << username << ' ' << atUser(username);
		cout << ' ' << tweets[numTweets - tweetIter - 1];
		cout << endl;
		tweetTopics = tweetTopics + scanTopics(tweets[numTweets - tweetIter - 1]) + " ";
		for (int j = 0; j < 79; j++) {
			cout << '-';
		}
		cout << endl;
		cout << endl;
	}
}

void begin() {
	followFile.open("followers.txt", std::fstream::in);

	if (!followFile)
	{
		followFile.open("followers.txt", std::fstream::trunc | std::fstream::out);
		followFile.close();
		followFile.open("followers.txt", std::fstream::in);
	}

	tweetFile.open("tweets.txt", std::fstream::in);

	if (!tweetFile)
	{
		tweetFile.open("tweets.txt", std::fstream::trunc | std::fstream::out);
		tweetFile.close();
		tweetFile.open("tweets.txt", std::fstream::in);
	}

	cout << "Enter a Username: ";
	getline(cin, username);
	cout << endl;
	if (tweetFile.is_open()) {
		while (getline(tweetFile, tweets[numTweets++])) {

		}
		displayTweets();
		tweetFile.close();
	}
	if (followFile.is_open()) {
		while (getline(followFile, followers[numFollows++])) {

		}
		followFile.close();
	}

	tweetFile.open("tweets.txt", std::fstream::app | std::fstream::in);
	followFile.open("followers.txt", std::fstream::app | std::fstream::in);
}

void displayInfo() {
	say = "USERNAME: " + username;
	cout << say << endl;
	say = "@USERNAME: " + atUser(username);
	cout << say << endl;
	cout << "TWEETS: " << numTweets << '\t' << "FOLLOWERS: " << numFollows << endl;
	cout << endl;
}

void getTweet() {
	cout << "-------YOUR MENU--------" << endl;
	cout << "Type 1 to post a tweet" << endl;
	cout << "Type 2 to add a follower" << endl;
	cout << "Type 3 to quit" << endl;
	cout << "------------------------" << endl;
	cout << "Enter a number from the menu: ";
	cin >> input;

	if (input == 1) {
		cout << "Please Enter a Tweet: " << endl;
		cin.ignore();
		getline(cin, tweets[numTweets++]);
		tweetFile << (tweets[numTweets - 1] + "\n");
		cout << endl;
	}
	else if (input == 2) {
		cout << "Please Enter a Follower: " << endl;
		cin.ignore();
		getline(cin, followers[numFollows++]);
		followers[numFollows - 1] = atUser(followers[numFollows - 1]);
		while (getline(followFile, followLine)) {
			cout << followLine << endl;
			if (followLine == followers[numFollows - 1]) {
				followers[numFollows - 1] = "";
				numFollows--;
				cout << "Follower Already Added." << endl;
				return;
			}
		}
		if (followers[numFollows - 1] != "") {
			followFile.close();
			followFile.open("followers.txt", std::fstream::app | std::fstream::in);
			followFile << (followers[numFollows - 1] + "\n");
		}
		cout << endl;
	}
	else if (input == 3) {
		q = true;
		followFile.close();
		tweetFile.close();
	}
	
}

void displayTopics() {
	cout << "TOPICS: " + tweetTopics;
	cout << endl;
	cout << endl;
}

int main() {
	begin();

	while (!q) {
		displayInfo();

		getTweet();

		if (tweets[numTweets - 1] == "q") {
			q = true;
		}

		displayTweets();

		displayTopics();
		
	}

	return 0;
}